!=========================================================================
! Copyright (C) GemTalk Systems 1986-2013.  All Rights Reserved.
!
! $Id: classset.gs 31442 2013-09-16 21:42:54Z stever $
!
! Superclass Hierarchy:
!   ClassSet, IdentitySet, IdentityBag, UnorderedCollection, Collection,
!   Object.
!
!=========================================================================

! Create the class ClassSet, if it does not already exist

expectvalue %String
run
  IdentitySet _newKernelSubclass: 'ClassSet'
    instVarNames: #()
    classVars: #()
    classInstVars: #()
    poolDictionaries: { }
    inDictionary: Globals
    constraints: Class
      options: #()
    reservedOop: 733 
%

removeallmethods ClassSet
removeallclassmethods ClassSet

category: 'For Documentation Installation only'
classmethod: ClassSet
installDocumentation

| doc txt |
doc := GsClassDocumentation newForClass: self.

txt := (GsDocText new) details:
'A ClassSet is an IdentitySet that holds only Class objects.' .
doc documentClassWith: txt.

self comment: doc asString.
%

! ------------------- Instance methods for ClassSet
category: 'Sorting'
method: ClassSet
sortAscending

"Returns an Array with the same (Class) elements as the receiver,
 in ascending order by class name."

^ self _sortPaths: #(#name) directions: #(true).
%

