!=========================================================================
! Copyright (C) GemTalk Systems 1986-2013.  All Rights Reserved.
!
! $Id: symbolkeyvaluedict.gs 31442 2013-09-16 21:42:54Z stever $
!
! Superclass Hierarchy:
!   SymbolKeyValueDictionary, IdentityKeyValueDictionary, KeyValueDictionary, 
!   AbstractDictionary, Collection, Object.
!
!=========================================================================

removeallmethods SymbolKeyValueDictionary
removeallclassmethods SymbolKeyValueDictionary

category: 'For Documentation Installation only'
classmethod: SymbolKeyValueDictionary
installDocumentation

| doc txt |
doc := GsClassDocumentation newForClass: self.

txt := (GsDocText new) details:
'A SymbolKeyValueDictionary is an IdentityKeyValueDictionary in which the keys
 are canonical symbols (a Symbol, DoubleByteSymbol, or QuadByteSymbol).  The separate
 implementation is necessary in order to support canonicalization of the symbols
 that are used as keys.

 SymbolKeyValueDictionaries cannot be used in symbol lists.' .
doc documentClassWith: txt.

self comment: doc asString.
%

! clusterDepthFirst inherited.

category: 'Updating'
method: SymbolKeyValueDictionary
at: aKey put: aValue

"Stores the aKey/aValue pair in the hash dictionary.   
 aKey must be convertible to a Symbol.

 Rebuilds the hash table if the addition caused the number of collisions 
 to exceed the limit allowed."

^ super at: (aKey asSymbol) put: aValue
%

category: 'Accessing'
method: SymbolKeyValueDictionary
keys

"Returns a SymbolSet containing the receiver's keys."

| result |
result := SymbolSet new .
self keysAndValuesDo:[ :aKey :aValue | result add: aKey ].
^ result
%

